/***************************************************************************
                          gmpmiddleware.h  -  High level routines. Protocol
                                              implementation ( automate )
                             -------------------
    begin                : Mon Dec 24 2001
    copyright            : (C) 2001 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GMP_MIDDLEWARE_H
#define GMP_MIDDLEWARE_H

#include <gmplowlevel.h>

/* Return values after a send command action */

#define GMP_RET_NOTHING       4  /* Nothing received since we sent an ACK */
#define GMP_RET_ACK           2  /* Received an explicit Ok */
#define GMP_RET_ACK_IMPLICIT  1  /* Received an implicit Ok through a new command */
#define GMP_SEND_ERR         -1  /* Could't send the command */
#define GMP_RET_DENY         -2  /* Received a DENY */
#define GMP_RET_CONFLICT     -3  /* Received an new command instead of ACK */
#define GMP_RET_RESEND			 -5  /* Received an old command: didn't see the previous Ok sent. */
#define GMP_RET_WAIT_ERROR   -6  /* Error by the lowlevel channel reading (broken pipe) */
#define GMP_RET_TIME_OUT     -7  /* Nothing receved within the time limits */

int gmp_middleware_automate( GMP_QUEUE *q_ch, int col, 
                             gboolean send, 
														 guchar cmd, guchar arg, int again );

#endif
