/***************************************************************************
                          gtkimlibpixmap.h  -  description
                             -------------------
    begin                : Sun Dec 8 2002
    copyright            : (C) 2002 by Dominique Laigle
    email                : liobadom@internet.lu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GTK_IMLIB_PIXMAP_H
#define GTK_IMLIB_PIXMAP_H

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/time.h>

#include <gdk/gdk.h>
#include <gtk/gtksignal.h>
#include <gtk/gtkwidget.h>
#include <gtk/gtkmain.h>

#include <gdk_imlib.h>

/*
 * This widget is a replacement of GnomePixmap limited to the 
 * presentation of a rendered ImLib image as GtkWidget. Since
 * we want to stay "PURE" GTK, we must avoid any reference to
 * the GnomeUI library.
 */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define GTK_IMLIB_PIXMAP(obj)		        ( GTK_CHECK_CAST ((obj), gtk_imlib_pixmap_get_type(), GtkImlibPixmap))
#define GTK_IMLIB_PIXMAP_CLASS(klass)	  ( GTK_CHECK_CLASS_CAST ((klass), GTK_TYPE_FLAG_BINAIRE, GtkImlibPixmapClass))
#define GTK_IS_IMLIB_PIXMAP(obj)		      ( GTK_CHECK_TYPE ( (obj), gtk_imlib_pixmap_get_type() ) )
#define GTK_IS_IMLIB_PIXMAP_CLASS(klass) ( GTK_CHECK_CLASS_TYPE ((klass), gtk_imlib_pixmap_get_type()))

typedef struct _GtkImlibPixmap	      GtkImlibPixmap;
typedef struct _GtkImlibPixmapClass  GtkImlibPixmapClass;

struct _GtkImlibPixmap
{
  GtkWidget widget;

  GdkImlibImage *im_image;  /* The imlib to load */
  GdkPixmap     *gdk_pix;   /* the pixmap rendered */
};

struct _GtkImlibPixmapClass
{
  GtkWidgetClass parent_class;			
};

GtkType	   gtk_imlib_pixmap_get_type( void );
GtkWidget* gtk_imlib_pixmap_new( GdkImlibImage *the_im );

gint gtk_imlib_pixmap_load( GtkImlibPixmap *, GdkImlibImage * );

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* GTK_IMLIB_PIXMAP_H */
