/***************************************************************************
                          maincallbacks.h  -  description
                             -------------------
    begin                : Wed Sep 19 2001
    copyright            : (C) 2001 by Dominique Laigle
    email                : liobadom@internet.lu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MAIN_CALL_BACKS_H
#define MAIN_CALL_BACKS_H

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>

#include <gdk_imlib.h>
#include <gtk/gtk.h>

#include <guigoban.h>
#include <guigobancx.h>
#include <guigobanclock.h>
#include <gtkimlibpixmap.h>
#include <gtkmessagebox.h>

#include <sgfdingo.h>
#include <gmpdingo.h>
		
#include <guisettings.h>

/* global widgets of the main level. They point thee same instanciated
 * in the main, but they are already casted. Thus, in this file we
 * only deal with full defined widget. It is the reponsability of the
 * main to perform the casted copies of those widget pointers. Since exiting
 * the application is fully asynchron, regardless of the status of the state
 * machine, the quit button stays within the visibility of the main level.
 */

GuiGobanCx     *the_goban_cx;
GuiGobanClock  *the_white_timer, *the_black_timer;
GuiGoban       *the_goban;
GtkImlibPixmap *the_ordinal_pixmap;

GdkImlibImage *white_pure_im,
              *black_pure_im,
              *white_ordi_im,
              *black_ordi_im;

GtkWidget   *edit_btn, *jeu_btn,
            *open_btn, *save_btn,*abandon_btn,
            *rwd_btn,  *bst_btn, *sst_btn, *fwd_btn,
            *pass_btn, *auto_btn,*handicap_btn, *ordinal_btn;

GtkButton   *the_ordinal_btn;
GtkLabel    *the_abandon_label;

/* global functions of the main level */

void slot_jeu_btn_clicked( void );
void slot_edit_btn_clicked( void );
void slot_open_btn_clicked( void );
void slot_save_btn_clicked( void );
void slot_abandon_btn_clicked( void );
void slot_rwd_btn_clicked( void );
void slot_bst_btn_clicked( void );
void slot_sst_btn_clicked( void );
void slot_fwd_btn_clicked( void );
void slot_pass_btn_clicked( void );
void slot_auto_btn_clicked( void );
void slot_handicap_btn_clicked( void );
void slot_ordinal_btn_clicked( void );

void slot_new_move( void );
void slot_end_of_game( void );

void enter_init_state( void );

gint
exit_dingoui( GtkWidget *, GdkEventAny *e, gpointer );

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* MAIN_CALL_BACKS_H */
