/***************************************************************************
                          sgfdingo.h  -  Minimum implementation of the Smart
													               Game Format. I didn't want to implement
the whole SGF functionalities since I didn't intend to rewrite "CGoban" with the
GTK Library. Thus, I only considered the main branch as I just wanted to follow 
some standard for saving and restoring games from/into a file. If one is 
interested in this work, then it should be certainly better to make use of one 
the SGF libraries that GnuGo or CGoban use.
                             -------------------
    begin                : Sun Sep 30 2001
    copyright            : (C) 2001 by Dominique Laigle
    email                : liobadom@internet.lu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef SGF_DINGO_H
#define SGF_DINGO_H

#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>

#include <glib.h>

#ifndef GO_REC
#define GO_REC

typedef struct {
                 guchar  start_pos[421]; /* Starting position - handicap */
                 gushort move[512];      /* List of all the moves played */
                 gushort last_move;	     /* Id of the last move - nb of moves */
                 guchar  first_stone;    /* Color of the first stone played */
               } GO_RECORD;
#endif


#ifndef GOBAN_CONTENT
#define GOBAN_CONTENT

/* goban contents */

enum {
       EMPTY,
       WHITE_STONE,
       BLACK_STONE,
       MARK,
       UNKNOWN_VALUE
     };

#endif

#define MAX_BUF_SIZE 1024

#ifndef _ACTION_ARGS_
#define _ACTION_ARGS_

enum { NOT_SUPPORTED, GM, SZ, HA, PL, AW, AB, B, W, THE_LAST };

#endif /* _ACTION_ARGS_ */

#ifndef _SGF_TREE_
#define _SGF_TREE_

typedef struct {
                 gint       node_action;
                 gint       point_id;
                 gchar      node_arg[8];
               } SGF_TREE;

#endif /* _SGF_TREE_ */


/* The only two public functions of this library */

gint sgf_dingo_import_file( GO_RECORD *, gint, gchar * );
gint sgf_dingo_export_to_file( GO_RECORD *, gint, gchar * );


#endif /* SGF_DINGO_H */
